var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var PubSubData_1, Subscribe_1, Unsubscribe_1, GetSubscribers_1;
import { Uint8ArrayList } from "uint8arraylist";
import { field, vec, variant, serialize, deserialize, option, } from "@dao-xyz/borsh";
export class PubSubMessage {
    static deserialize(bytes) {
        const first = bytes instanceof Uint8Array ? bytes[0] : bytes.get(0);
        if (first === 0) {
            return PubSubData.deserialize(bytes);
        }
        if (first === 1) {
            return Subscribe.deserialize(bytes);
        }
        if (first === 2) {
            return Unsubscribe.deserialize(bytes);
        }
        if (first === 3) {
            return GetSubscribers.deserialize(bytes);
        }
        throw new Error("Unsupported");
    }
}
export const toUint8Array = (arr) => arr instanceof Uint8ArrayList ? arr.subarray() : arr;
let PubSubData = PubSubData_1 = class PubSubData extends PubSubMessage {
    topics;
    data;
    constructor(options) {
        super();
        this.data =
            options.data instanceof Uint8Array
                ? options.data
                : options.data.subarray();
        this.topics = options.topics;
    }
    _serialized;
    serialize() {
        if (this._serialized) {
            return this._serialized;
        }
        return serialize(this);
    }
    static deserialize(bytes) {
        const ret = deserialize(bytes instanceof Uint8Array ? bytes : bytes.subarray(), PubSubData_1);
        if (bytes instanceof Uint8ArrayList) {
            ret._serialized = bytes;
        }
        return ret;
    }
};
__decorate([
    field({ type: vec("string") }),
    __metadata("design:type", Array)
], PubSubData.prototype, "topics", void 0);
__decorate([
    field({ type: Uint8Array }),
    __metadata("design:type", Uint8Array)
], PubSubData.prototype, "data", void 0);
PubSubData = PubSubData_1 = __decorate([
    variant(0),
    __metadata("design:paramtypes", [Object])
], PubSubData);
export { PubSubData };
let Subscription = class Subscription {
    topic;
    data; // if omitted, the subcription event is a no-op (will not replace anything)
    constructor(topic, data) {
        this.topic = topic;
        this.data = data;
    }
};
__decorate([
    field({ type: "string" }),
    __metadata("design:type", String)
], Subscription.prototype, "topic", void 0);
__decorate([
    field({ type: option(Uint8Array) }),
    __metadata("design:type", Uint8Array)
], Subscription.prototype, "data", void 0);
Subscription = __decorate([
    variant(0),
    __metadata("design:paramtypes", [String, Uint8Array])
], Subscription);
export { Subscription };
let Subscribe = Subscribe_1 = class Subscribe extends PubSubMessage {
    subscriptions;
    constructor(options) {
        super();
        this.subscriptions = options.subscriptions;
    }
    _serialized;
    serialize() {
        if (this._serialized) {
            return this._serialized;
        }
        return serialize(this);
    }
    static deserialize(bytes) {
        const ret = deserialize(bytes instanceof Uint8Array ? bytes : bytes.subarray(), Subscribe_1);
        if (bytes instanceof Uint8ArrayList) {
            ret._serialized = bytes;
        }
        return ret;
    }
};
__decorate([
    field({ type: vec(Subscription) }),
    __metadata("design:type", Array)
], Subscribe.prototype, "subscriptions", void 0);
Subscribe = Subscribe_1 = __decorate([
    variant(1),
    __metadata("design:paramtypes", [Object])
], Subscribe);
export { Subscribe };
let Unsubscription = class Unsubscription {
    topic;
    constructor(topic) {
        this.topic = topic;
    }
};
__decorate([
    field({ type: "string" }),
    __metadata("design:type", String)
], Unsubscription.prototype, "topic", void 0);
Unsubscription = __decorate([
    variant(0),
    __metadata("design:paramtypes", [String])
], Unsubscription);
export { Unsubscription };
let Unsubscribe = Unsubscribe_1 = class Unsubscribe extends PubSubMessage {
    unsubscriptions;
    constructor(options) {
        super();
        this.unsubscriptions = options.topics.map((x) => new Unsubscription(x));
    }
    _serialized;
    serialize() {
        if (this._serialized) {
            return this._serialized;
        }
        return serialize(this);
    }
    static deserialize(bytes) {
        const ret = deserialize(bytes instanceof Uint8Array ? bytes : bytes.subarray(), Unsubscribe_1);
        if (bytes instanceof Uint8ArrayList) {
            ret._serialized = bytes;
        }
        return ret;
    }
};
__decorate([
    field({ type: vec(Unsubscription) }),
    __metadata("design:type", Array)
], Unsubscribe.prototype, "unsubscriptions", void 0);
Unsubscribe = Unsubscribe_1 = __decorate([
    variant(2),
    __metadata("design:paramtypes", [Object])
], Unsubscribe);
export { Unsubscribe };
let GetSubscribers = GetSubscribers_1 = class GetSubscribers extends PubSubMessage {
    topics;
    // add stop filter list to prvent this message from propgating to unecessary peers
    constructor(options) {
        super();
        this.topics = options.topics;
    }
    _serialized;
    serialize() {
        if (this._serialized) {
            return this._serialized;
        }
        return serialize(this);
    }
    static deserialize(bytes) {
        const ret = deserialize(bytes instanceof Uint8Array ? bytes : bytes.subarray(), GetSubscribers_1);
        if (bytes instanceof Uint8ArrayList) {
            ret._serialized = bytes;
        }
        return ret;
    }
};
__decorate([
    field({ type: vec("string") }),
    __metadata("design:type", Array)
], GetSubscribers.prototype, "topics", void 0);
GetSubscribers = GetSubscribers_1 = __decorate([
    variant(3),
    __metadata("design:paramtypes", [Object])
], GetSubscribers);
export { GetSubscribers };
//# sourceMappingURL=messages.js.map